%define _xinputconf %{_sysconfdir}/X11/xinit/xinput.d/fcitx.conf
%{!?gtk2_binary_version: %define gtk2_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-2.0)}
%{!?gtk3_binary_version: %define gtk3_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-3.0)}

%define	version 4.2.8.3

# NOTE: set prerelease to 0 for official releases, 1 for pre-releases
%define prerelease 0

%if %prerelease
%define release	%mkrel -c %{prerelease} %{rel}
%define tarballver %version-%prerelease
%else
%define release %mkrel %{rel}
%define tarballver %version
%endif

Summary:	Fcitx- an input method framework
Name:		fcitx
Version:	%{version}
Release:	%mkrel 1
License:	GPLv2+
Group:		System/Internationalization
URL:		http://code.google.com/p/%{name}/
Source0:  	http://download.fcitx-im.org/%{name}/%{name}-%{version}_dict.tar.xz
Source1:	xinput-%{name}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:  automake
BuildRequires:  cmake
BuildRequires:  gettext-devel
BuildRequires:  libx11-devel
BuildRequires:  libxft-devel
BuildRequires:  xpm-devel
BuildRequires:  libxext-devel
BuildRequires:  dbus-glib-devel
BuildRequires:  libxkbfile-devel
BuildRequires:  enchant-devel
BuildRequires:  iso-codes-devel
BuildRequires:  libgirepository-devel
BuildRequires:  gtk+2-devel
BuildRequires:  gtk+3-devel
BuildRequires:  cairo-devel
BuildRequires:  pango-devel
BuildRequires:  intltool
BuildRequires:  icu-devel
BuildRequires:  desktop-file-utils
BuildRequires:  doxygen
BuildRequires:  x11-proto-devel
BuildRequires:  x11-xtrans-devel
BuildRequires:  libxml2-devel
BuildRequires:  lua5.1-devel
Requires:  %{name}-gtk2 = %{version}-%{release}
Requires:  %{name}-data = %{version}-%{release}
Requires:  %{name}-libs = %{version}-%{release}
Requires:  setime >= 0.87


%description
Fcitx is an input method framework with extension support.
Currently it supports linux and Unix system, like freebsd.
It has three builtin Input Method Engine, Pinyin, QuWei and Table-based input methods.

# ------------------------------------------

%package data
Summary:    Data files of FCITX
Group:      System/Internationalization
BuildArch:  noarch

%description data
The %{name}-data package provides shared datas for FCITX.

# ------------------------------------------

%package libs
Summary:   Shared libraries for FCITX
Group:     System/Internationalization

%description libs
This package provides shared libraries for FCITX.

%post libs
/sbin/ldconfig

%postun libs
/sbin/ldconfig

# ------------------------------------------

%package devel
Summary:   fcitx development library
Group:     Development/C
Requires:  %{name}-libs = %{version}-%{release}

%description devel
This package contains libraries and header files necessary for developing programs using FCITX libraries.

# ------------------------------------------

%package gtk2
Summary:   fcitx im module for gtk2
Group:     System/Internationalization
Requires:  %{name}-libs = %{version}-%{release}
Requires(post):    gtk+2.0
Requires(postun):  gtk+2.0

%description gtk2
This package contains fcitx im module for gtk2.

%post gtk2
#%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib
%{_bindir}/gtk-query-immodules-2.0 --update-cache

%postun gtk2
#%{_bindir}/gtk-query-immodules-2.0 > %{_sysconfdir}/gtk-2.0/gtk.immodules.%_lib
%{_bindir}/gtk-query-immodules-2.0 --update-cache

# ------------------------------------------

%package gtk3
Summary:   fcitx im module for gtk3
Group:     System/Internationalization
Requires:  %{name}-libs = %{version}-%{release}
Requires(post):    gtk+3.0
Requires(postun):  gtk+3.0

%description gtk3
This package contains fcitx im module for gtk3.

%post gtk3
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache

%postun gtk3
%{_bindir}/gtk-query-immodules-3.0-%{__isa_bits} --update-cache

# ------------------------------------------

%package qt4
Summary:   fcitx im module for Qt4
Group:     System/Internationalization
BuildRequires:  libqt4-devel
Requires:  %{name}-libs = %{version}-%{release}
Requires:  qt4-common

%description qt4
This package contains fcitx im module for Qt4.

# ------------------------------------------

#%%package gir
#Summary:   GObject Introspection interface description for fcitx
#Group:     System/Libraries
#Requires:  %{name} = %{version}-%{release}

#%%description gir
#GObject Introspection interface description for fcitx.

# ------------------------------------------

%package table-chinese
Summary:   Chinese table of FCITX
Group:     System/Internationalization
BuildArch: noarch
Requires:	 locales-zh
Requires:  %{name} = %{version}-%{release}

%description table-chinese
This package provides Chinese table for FCITX.

# ------------------------------------------

%package pinyin
Summary:   Chinese Pinyin Engine for Fcitx
Group:     System/Internationalization
Requires:  %{name} = %{version}-%{release}
Requires:	 locales-zh

%description pinyin
This package contains Chinese pinyin engine for fcitx.

# ------------------------------------------

%package qw
Summary:   Chinese QuWei Engine for Fcitx
Group:     System/Internationalization
Requires:  %{name} = %{version}-%{release}
Requires:  locales-zh

%description qw
This package contains Chinese quwei engine for fcitx.

# ------------------------------------------


%prep
%setup -q -n %{name}-%{version}


%build
%cmake \
  -DENABLE_GTK2_IM_MODULE=ON \
  -DENABLE_GTK3_IM_MODULE=ON \
  -DENABLE_QT_IM_MODULE=ON \
  -DENABLE_OPENCC=Off \
  -DENABLE_XDGAUTOSTART=Off \
  -DENABLE_LUA=On \
  -DCMAKE_SKIP_RPATH=Off

%make

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std -C build
rm -f %{buildroot}%{_libdir}/*.la


desktop-file-install --delete-original --vendor="" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/%{name}-skin-installer.desktop

desktop-file-install --delete-original --vendor="" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/%{name}-configtool.desktop

desktop-file-install --delete-original --vendor="" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop

rm -f $RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart/fcitx-autostart.desktop

%find_lang %{name}


%clean
rm -rf $RPM_BUILD_ROOT


%post 
%{_sbindir}/alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_xinputconf} 55 || :
update-desktop-database %{_datadir}/applications &>/dev/null || :

%postun  
if [ "$1" = "0" ]; then
  %{_sbindir}/alternatives --remove xinputrc %{_xinputconf} || :
  # if alternative was set to manual, reset to auto
  [ -L %{_sysconfdir}/alternatives/xinputrc -a "`readlink %{_sysconfdir}/alternatives/xinputrc`" = "%{_xinputconf}" ] && %{_sbindir}/alternatives --auto xinputrc || :
fi
update-desktop-database %{_datadir}/applications &>/dev/null || :


%files -f %{name}.lang
%defattr(-,root,root)
%doc AUTHORS ChangeLog THANKS TODO COPYING
%attr(0644,-,-) %doc doc/*.txt doc/*.htm
%{_bindir}/fcitx
%{_bindir}/fcitx-configtool
%{_bindir}/fcitx-remote
%{_bindir}/fcitx-skin-installer
%{_bindir}/fcitx-dbus-watcher
%{_bindir}/fcitx-diagnose
%{_libdir}/%{name}/fcitx-autoeng.so
%{_libdir}/%{name}/fcitx-chttrans.so
%{_libdir}/%{name}/fcitx-classic-ui.so
%{_libdir}/%{name}/fcitx-clipboard.so
%{_libdir}/%{name}/fcitx-dbus.so
%{_libdir}/%{name}/fcitx-freedesktop-notify.so
%{_libdir}/%{name}/fcitx-fullwidth-char.so
%{_libdir}/%{name}/fcitx-imselector.so
%{_libdir}/%{name}/fcitx-ipc.so
%{_libdir}/%{name}/fcitx-keyboard.so
%{_libdir}/%{name}/fcitx-kimpanel-ui.so
%{_libdir}/%{name}/fcitx-lua.so
%{_libdir}/%{name}/fcitx-notificationitem.so
%{_libdir}/%{name}/fcitx-remote-module.so
%{_libdir}/%{name}/fcitx-spell.so
%{_libdir}/%{name}/fcitx-unicode.so
%{_libdir}/%{name}/fcitx-vk.so
%{_libdir}/%{name}/fcitx-x11.so
%{_libdir}/%{name}/fcitx-xim.so
%{_libdir}/%{name}/fcitx-xkb.so
%{_libdir}/%{name}/fcitx-xkbdbus.so
%{_datadir}/%{name}/dbus/daemon.conf
%{_datadir}/applications/*.desktop
%{_datadir}/mime/packages/*.xml
%{_mandir}/man1/fcitx.1.bz2
%{_mandir}/man1/fcitx-remote.1.bz2
%{_datadir}/dbus-1/services/org.fcitx.Fcitx.service


%files libs
%defattr(-,root,root,-)
%{_libdir}/libfcitx*.so.*
%{_libdir}/%{name}/fcitx-punc.so
%{_libdir}/%{name}/fcitx-quickphrase.so
%{_libdir}/girepository-1.0/Fcitx-1.0.typelib


%files data
%defattr(-,root,root,-)
%{_iconsdir}/*/*/*/*
%{_datadir}/%{name}/skin/*
%{_datadir}/%{name}/addon/fcitx-punc.conf
%{_datadir}/%{name}/addon/fcitx-quickphrase.conf
%{_datadir}/%{name}/addon/fcitx-autoeng.conf
%{_datadir}/%{name}/addon/fcitx-chttrans.conf
%{_datadir}/%{name}/addon/fcitx-classic-ui.conf
%{_datadir}/%{name}/addon/fcitx-clipboard.conf
%{_datadir}/%{name}/addon/fcitx-dbus.conf
%{_datadir}/%{name}/addon/fcitx-freedesktop-notify.conf
%{_datadir}/%{name}/addon/fcitx-fullwidth-char.conf
%{_datadir}/%{name}/addon/fcitx-imselector.conf
%{_datadir}/%{name}/addon/fcitx-ipc.conf
%{_datadir}/%{name}/addon/fcitx-keyboard.conf
%{_datadir}/%{name}/addon/fcitx-kimpanel-ui.conf
%{_datadir}/%{name}/addon/fcitx-lua.conf
%{_datadir}/%{name}/addon/fcitx-notificationitem.conf
%{_datadir}/%{name}/addon/fcitx-remote-module.conf
%{_datadir}/%{name}/addon/fcitx-spell.conf
%{_datadir}/%{name}/addon/fcitx-unicode.conf
%{_datadir}/%{name}/addon/fcitx-vk.conf
%{_datadir}/%{name}/addon/fcitx-x11.conf
%{_datadir}/%{name}/addon/fcitx-xim.conf
%{_datadir}/%{name}/addon/fcitx-xkb.conf
%{_datadir}/%{name}/addon/fcitx-xkbdbus.conf
%{_datadir}/%{name}/configdesc/addon.desc
%{_datadir}/%{name}/configdesc/config.desc
%{_datadir}/%{name}/configdesc/fcitx-autoeng.desc
%{_datadir}/%{name}/configdesc/fcitx-chttrans.desc
%{_datadir}/%{name}/configdesc/fcitx-classic-ui.desc
%{_datadir}/%{name}/configdesc/fcitx-clipboard.desc
%{_datadir}/%{name}/configdesc/fcitx-imselector.desc
%{_datadir}/%{name}/configdesc/fcitx-keyboard.desc
%{_datadir}/%{name}/configdesc/fcitx-quickphrase.desc
%{_datadir}/%{name}/configdesc/fcitx-spell.desc
%{_datadir}/%{name}/configdesc/fcitx-unicode.desc
%{_datadir}/%{name}/configdesc/fcitx-xim.desc
%{_datadir}/%{name}/configdesc/fcitx-xkb.desc
%{_datadir}/%{name}/configdesc/inputmethod.desc
%{_datadir}/%{name}/configdesc/profile.desc
%{_datadir}/%{name}/configdesc/skin.desc
%{_datadir}/%{name}/data/*
%{_datadir}/%{name}/spell/*


%files table-chinese
%defattr(-,root,root,-)
%{_bindir}/mb2txt
%{_bindir}/txt2mb
%{_libdir}/%{name}/fcitx-table.so
%{_datadir}/%{name}/addon/fcitx-table.conf
%{_datadir}/%{name}/configdesc/table.desc
%{_datadir}/%{name}/configdesc/fcitx-table.desc
%{_datadir}/%{name}/table/*
%{_datadir}/%{name}/imicon/ziranma.png
%{_datadir}/%{name}/imicon/wubi.png
%{_datadir}/%{name}/imicon/wbpy.png
%{_datadir}/%{name}/imicon/erbi.png
%{_datadir}/%{name}/imicon/cangjie.png
%{_mandir}/man1/mb2txt.1.bz2
%{_mandir}/man1/txt2mb.1.bz2


%files gtk2
%defattr(-,root,root)
#%{_libdir}/gtk-2.0/%{gtk2_binary_version}/immodules/im-fcitx.so
%{_libdir}/gtk-2.0/*/immodules/im-fcitx.so

%files gtk3
%defattr(-,root,root)
#%{_libdir}/gtk-3.0/%{gtk3_binary_version}/immodules/im-fcitx.so
%{_libdir}/gtk-3.0/*/immodules/im-fcitx.so

%files qt4
%defattr(-,root,root)
%{qt4plugins}/inputmethods/qtim-fcitx.so
%{_libdir}/%{name}/libexec/fcitx-qt-gui-wrapper
%{_libdir}/%{name}/qt/libfcitx-quickphrase-editor.so


#%%files gir
#%%defattr(-,root,root)
#%%{_libdir}/girepository-1.0/Fcitx-1.0.typelib


%files devel
%defattr(-,root,root)
%{_bindir}/fcitx4-config
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/%{name}/libexec/comp-spell-dict
%{_libdir}/%{name}/libexec/fcitx-po-parser
%{_libdir}/%{name}/libexec/fcitx-scanner
%{_libdir}/pkgconfig/*.pc
%{_datadir}/cmake/%{name}
%{_datadir}/gir-1.0/Fcitx-1.0.gir


%files pinyin
%defattr(-,root,root,-)
%{_bindir}/createPYMB
%{_bindir}/readPYMB
%{_bindir}/readPYBase
%{_bindir}/mb2org
%{_bindir}/scel2org
%{_libdir}/%{name}/fcitx-pinyin.so
%{_libdir}/%{name}/fcitx-pinyin-enhance.so
%{_datadir}/%{name}/inputmethod/pinyin.conf
%{_datadir}/%{name}/inputmethod/shuangpin.conf
%{_datadir}/%{name}/pinyin/
%{_datadir}/%{name}/configdesc/fcitx-pinyin.desc
%{_datadir}/%{name}/configdesc/fcitx-pinyin-enhance.desc
%{_datadir}/%{name}/addon/fcitx-pinyin.conf
%{_datadir}/%{name}/addon/fcitx-pinyin-enhance.conf
%{_datadir}/%{name}/imicon/pinyin.png
%{_datadir}/%{name}/imicon/shuangpin.png
%{_datadir}/%{name}/py-enhance/
%{_mandir}/man1/createPYMB.1.bz2
%{_mandir}/man1/readPYMB.1.bz2
%{_mandir}/man1/readPYBase.1.bz2
%{_mandir}/man1/mb2org.1.bz2
%{_mandir}/man1/scel2org.1.bz2


%files qw
%defattr(-,root,root,-)
%{_libdir}/%{name}/fcitx-qw.so
%{_datadir}/%{name}/inputmethod/qw.conf
%{_datadir}/%{name}/addon/fcitx-qw.conf



%changelog
* Wed Nov 13 2013 pinoc <vogtpet at gmail.com> 4.2.8.3-1pclos2013
- 4.2.8.3
- build acc tomcat

* Wed May 01 2013 Texstar <texstar at gmail.com> 4.1.2-2pclos2013
- fix broken dependency

* Sat Nov 19 2011 Archie Arevalo <pclinuxos.ph at gmail.com> 4.1.2-1pclos2011
- Rebuild for x86_64

* Wed Jan 05 2011 Texstar <texstar at gmail.com> 4.0.1-1pclos2010
- 4.0.1

* Tue Jun 01 2010 JohanSJA <johansja@fastmail.fm> 3.6.3-1pclos2010
- Build for PCLinuxOS 2010 imported from mdv

